/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.records.TCoreStudygroupRecord;

import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreStudygroup extends TableImpl<TCoreStudygroupRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_studygroup</code>
     */
    public static final TCoreStudygroup T_CORE_STUDYGROUP = new TCoreStudygroup();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreStudygroupRecord> getRecordType() {
        return TCoreStudygroupRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_studygroup.pk</code>.
     */
    public final TableField<TCoreStudygroupRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_studygroup.fk_element</code>.
     */
    public final TableField<TCoreStudygroupRecord, Integer> FK_ELEMENT = createField(DSL.name("fk_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.t_core_studygroup.name</code>.
     */
    public final TableField<TCoreStudygroupRecord, String> NAME = createField(DSL.name("name"), SQLDataType.CLOB.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_studygroup.unique_name_prefix</code>.
     */
    public final TableField<TCoreStudygroupRecord, String> UNIQUE_NAME_PREFIX = createField(DSL.name("unique_name_prefix"), SQLDataType.CLOB.nullable(false), this, "");

    private TCoreStudygroup(Name alias, Table<TCoreStudygroupRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreStudygroup(Name alias, Table<TCoreStudygroupRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_studygroup</code> table
     * reference
     */
    public TCoreStudygroup(String alias) {
        this(DSL.name(alias), T_CORE_STUDYGROUP);
    }

    /**
     * Create an aliased <code>common_dd.t_core_studygroup</code> table
     * reference
     */
    public TCoreStudygroup(Name alias) {
        this(alias, T_CORE_STUDYGROUP);
    }

    /**
     * Create a <code>common_dd.t_core_studygroup</code> table reference
     */
    public TCoreStudygroup() {
        this(DSL.name("t_core_studygroup"), null);
    }

    public <O extends Record> TCoreStudygroup(Table<O> path, ForeignKey<O, TCoreStudygroupRecord> childPath, InverseForeignKey<O, TCoreStudygroupRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_STUDYGROUP);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreStudygroupPath extends TCoreStudygroup implements Path<TCoreStudygroupRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreStudygroupPath(Table<O> path, ForeignKey<O, TCoreStudygroupRecord> childPath, InverseForeignKey<O, TCoreStudygroupRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreStudygroupPath(Name alias, Table<TCoreStudygroupRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreStudygroupPath as(String alias) {
            return new TCoreStudygroupPath(DSL.name(alias), this);
        }

        @Override
        public TCoreStudygroupPath as(Name alias) {
            return new TCoreStudygroupPath(alias, this);
        }

        @Override
        public TCoreStudygroupPath as(Table<?> alias) {
            return new TCoreStudygroupPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreStudygroupRecord, Integer> getIdentity() {
        return (Identity<TCoreStudygroupRecord, Integer>) super.getIdentity();
    }

    @Override
    public List<UniqueKey<TCoreStudygroupRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.T_CORE_STUDYGROUP_NAME_KEY, Keys.T_CORE_STUDYGROUP_UNIQUE_NAME_PREFIX_KEY);
    }

    @Override
    public List<ForeignKey<TCoreStudygroupRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_STUDYGROUP__T_CORE_STUDYGROUP_FK_ELEMENT_FKEY);
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table.
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, Keys.T_CORE_STUDYGROUP__T_CORE_STUDYGROUP_FK_ELEMENT_FKEY, null);

        return _tCoreElementHierarchy;
    }

    @Override
    public TCoreStudygroup as(String alias) {
        return new TCoreStudygroup(DSL.name(alias), this);
    }

    @Override
    public TCoreStudygroup as(Name alias) {
        return new TCoreStudygroup(alias, this);
    }

    @Override
    public TCoreStudygroup as(Table<?> alias) {
        return new TCoreStudygroup(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreStudygroup rename(String name) {
        return new TCoreStudygroup(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreStudygroup rename(Name name) {
        return new TCoreStudygroup(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreStudygroup rename(Table<?> name) {
        return new TCoreStudygroup(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreStudygroup where(Condition condition) {
        return new TCoreStudygroup(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreStudygroup where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreStudygroup where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreStudygroup where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreStudygroup where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreStudygroup where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreStudygroup where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreStudygroup where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreStudygroup whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreStudygroup whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
